require 'dispatch/external_ids/version'
require 'httparty'

module Dispatch
  module ExternalIDs

    class DispatchMe
      include HTTParty
      base_uri ENV['EXTERNAL_IDS_ENDPOINT_URL']

      def self.fetch(client:, entity:, id:, access_token: nil)
        query = {
          filter: {
            client: client,
            type: entity,
            id: id,
          },
          access_token: access_token
        }

        res = get('/v1/records.json', { query: query })
        res['records'] if res.code == 200
      end
    end

    class ThirdParty
      include HTTParty
      base_uri ENV['EXTERNAL_IDS_ENDPOINT_URL']

      def self.fetch(client:, entity:, id:, access_token: nil)
        query = {
          filter: {
            client: client,
            dispatch_type: entity,
            dispatch_id: id,
          },
          access_token: access_token
        }

        res = get('/v1/records.json', { query: query })
        res['records'] if res.code == 200
      end
    end
  end
end
